/*
 *	fram.c
 *
 *	VAX11(ڐA)
 *
 *	* Sat Dec 09 18:40:08 JST 2006 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

void
DrawPoint(int x, int y, int color)
{
	x = (x - 144) / 4;
	y = (y +  16) / 4;
	render_point(&render, x, y, color);
}

void
DrawString(int x, int y, const char* str, int color)
{
	int c;
	DRAW_OBJECT obj;

	x = (x - 144);
	y = (y +  16) / 4;

	obj.dest = (PIECE_VRAM*)render.surface;
	//obj.dx = ɐݒ
	obj.dy = y;
	obj.dw = 3;
	obj.dh = 4;
	//
	obj.src = &texture_table[TEX_FONT];
	//obj.sx = ɐݒ
	//obj.sy = ɐݒ
	obj.clip.left = render.left;
	obj.clip.top = render.top;
	obj.clip.right = render.right;
	obj.clip.bottom = render.bottom;
	//
	obj.param = color;

	while((c = *str++) != '\0') {
		if(c != ' ') {
			obj.dx = x / 4;
			obj.sx = (c << 2) & 0x3c;
			obj.sy = (c >> 2) & 0x3c;
			DrawObject1B(obj);
		}
		x += 9;
	}
}

void
DrawObject1B(DRAW_OBJECT obj)
{
	PIECE_BMP src = *obj.src;
	PIECE_VRAM dest = *obj.dest;
	int color = obj.param;
	int n, x, y, step, dest_stride, src_stride;
	unsigned char *dest_buf, *src_mask, mask;

	if(obj.dx < obj.clip.left) {
		n = obj.clip.left - obj.dx;
		obj.dx = obj.clip.left;
		obj.dw -= n;
		obj.sx += n;
	}
	if(obj.dx + obj.dw > obj.clip.right) {
		obj.dw = obj.clip.right - obj.dx;
	}
	if(obj.dw <= 0) return;
	if(obj.dy < obj.clip.top) {
		n = obj.clip.top - obj.dy;
		obj.dy = obj.clip.top;
		obj.dh -= n;
		obj.sy += n;
	}
	if(obj.dy + obj.dh > obj.clip.bottom) {
		obj.dh = obj.clip.bottom - obj.dy;
	}
	if(obj.dh <= 0) return;

	n = (src.header.w * obj.sy + obj.sx) / 8;
	src_mask = src.buf/*src.maskł͂Ȃ!!*/ + n;
	src_stride = src.header.w / 8 - ((obj.sx & 7) + obj.dw - 1) / 8;

	dest_buf = dest.buf + dest.w * obj.dy + obj.dx;
	dest_stride = dest.w - obj.dw;

	y = obj.dh;
	do {
		step = obj.sx & 7;
		mask = *src_mask;

		x = obj.dw;
		switch(step) {
LOOP:
			mask = *++src_mask;
#define PIXEL(p, m)							\
			if(!(mask & (1 << (m)))) *dest_buf = color;	\
			dest_buf++;					\
			if(--x == 0) break;
		case 0:  PIXEL(3, 7);
		case 1:  PIXEL(2, 6);
		case 2:  PIXEL(1, 5);
		case 3:  PIXEL(0, 4);
		case 4:  PIXEL(7, 3);
		case 5:  PIXEL(6, 2);
		case 6:  PIXEL(5, 1);
		default: PIXEL(4, 0); goto LOOP;
#undef PIXEL
		}

		src_mask += src_stride;
		dest_buf += dest_stride;
	} while(--y != 0);
}

void
CollisionCheck()
{
	int group;
	ACT* actp;
	ACT* eactp;

	/* SANg[v */
	//for(group = 0; group < ACT_GROUP_MAX; group++) {
	//GROUP_00(C)GROUP_01(GtFNg)͓蔻Ȃ̂ŁAȗčB
	for(group = 2; group < ACT_GROUP_MAX; group++) {
		for(actp = ActIndex[group][ACT_TOP].next_act;
		    actp != &ActIndex[group][ACT_BOTTOM];
		    actp = actp->next_act) {
			/* ɂ镪 */
			switch(get_cflag(actp)) {
			case ACTF_SHIP:
				for(eactp = ActIndex[GROUP_ENEMY][ACT_TOP].next_act;
				    eactp != &ActIndex[GROUP_ENEMY][ACT_BOTTOM];
				    eactp = eactp->next_act) {
					switch(get_cflag(eactp)) {
					case ACTF_ENEMY:
						if(!(actp->actid & ACTF_MUTEKI)) {
							if(CollisionCheckSub(actp, eactp)) {
								actp->ext_dat = eactp;
								if(actp->int_adr) {
									actp->int_adr(actp);
								}
								goto L_NEXT;
							}
						}
						break;
					case ACTF_CHIP:
						if(CollisionCheckSub(actp, eactp)) {
							actp->ext_dat = eactp;
							eactp->ext_dat = actp;
							if(actp->int_adr) {
								actp->int_adr(actp);
							}
							if(eactp->int_adr) {
								eactp->int_adr(eactp);
							}
						}
						break;
					}
				}
				for(eactp = ActIndex[GROUP_ESHOT][ACT_TOP].next_act;
				    eactp != &ActIndex[GROUP_ESHOT][ACT_BOTTOM];
				    eactp = eactp->next_act) {
					switch(get_cflag(eactp)) {
					case ACTF_ESHOT:
						if(!(actp->actid & ACTF_MUTEKI)) {
							if(CollisionCheckSub(actp, eactp)) {
								actp->ext_dat = eactp;
								if(actp->int_adr) {
									actp->int_adr(actp);
								}
								goto L_NEXT;
							}
						}
						break;
					}
				}
				break;
			case ACTF_SSHOT:
				for(eactp = ActIndex[GROUP_ENEMY][ACT_TOP].next_act;
				    eactp != &ActIndex[GROUP_ENEMY][ACT_BOTTOM];
				    eactp = eactp->next_act) {
					switch(get_cflag(eactp)) {
					case ACTF_ENEMY:
						if(CollisionCheckSub(actp, eactp)) {
							actp->ext_dat = eactp;
							eactp->ext_dat = actp;
							if(eactp->int_adr) {
								eactp->int_adr(eactp);
							}
							if(actp->int_adr) {
								actp->int_adr(actp);
							}
							goto L_NEXT;
						}
						break;
					}
				}
				break;
			case ACTF_BOMB:
				for(eactp = ActIndex[GROUP_ENEMY][ACT_TOP].next_act;
				    eactp != &ActIndex[GROUP_ENEMY][ACT_BOTTOM];
				    eactp = eactp->next_act) {
					switch(get_cflag(eactp)) {
					case ACTF_ENEMY:
						if(CollisionCheckSub(actp, eactp)) {
							eactp->ext_dat = actp;
							if(eactp->int_adr) {
								eactp->int_adr(eactp);
							}
						}
						break;
					}
				}
				for(eactp = ActIndex[GROUP_ESHOT][ACT_TOP].next_act;
				    eactp != &ActIndex[GROUP_ESHOT][ACT_BOTTOM];
				    eactp = eactp->next_act) {
					switch(get_cflag(eactp)) {
					case ACTF_ESHOT:
						if(CollisionCheckSub(actp, eactp)) {
							eactp->ext_dat = actp;
							if(eactp->int_adr) {
								eactp->int_adr(eactp);
							}
						}
						break;
					}
				}
				break;
			}
L_NEXT:
		}
	}
}

int
CollisionCheckSub(ACT* actp, ACT* eactp)
{
#define srect_left   fsub(spos[X], fidiv(scol[X], 2))
#define srect_right  fadd(spos[X], fidiv(scol[X], 2))
#define srect_top    fsub(spos[Y], fidiv(scol[Y], 2))
#define srect_bottom fadd(spos[Y], fidiv(scol[Y], 2))
#define trect_left   fsub(tpos[X], fidiv(tcol[X], 2))
#define trect_right  fadd(tpos[X], fidiv(tcol[X], 2))
#define trect_top    fsub(tpos[Y], fidiv(tcol[Y], 2))
#define trect_bottom fadd(tpos[Y], fidiv(tcol[Y], 2))

	const fixed* spos = actp->pos;
	const fixed* scol = actp->col;
	const fixed* tpos = eactp->pos;
	const fixed* tcol = eactp->col;

	if(fcom(srect_left, >, trect_right)) return FALSE;
	if(fcom(trect_left, >, srect_right)) return FALSE;
	if(fcom(srect_top, >, trect_bottom)) return FALSE;
	if(fcom(trect_top, >, srect_bottom)) return FALSE;

	return TRUE;

#undef srect_left
#undef srect_right
#undef srect_top
#undef srect_bottom
#undef trect_left
#undef trect_right
#undef trect_top
#undef trect_bottom
}

